// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "SimpleDrawing.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

    // 1. 尴ü
	// Ŭ̾Ʈ  ʷϻ ġ 귯÷ ä.
    CRect rect;
    GetClientRect(&rect);
    CBrush brush(HS_DIAGCROSS, RGB(0, 255, 0));
    dc.SelectObject(&brush);
    dc.Rectangle(&rect);    
    // 輱  ΰ ȸ ä 簢 ׸.
    dc.SelectStockObject(NULL_PEN);
    dc.SelectStockObject(GRAY_BRUSH);
    dc.Rectangle(50, 350, 200, 550);
    // 輱 ̰ ΰ  ִ 簢 ׸.
    dc.SelectStockObject(BLACK_PEN);
    dc.SelectStockObject(NULL_BRUSH);
    dc.Rectangle(250, 350, 400, 550);

	// 2. line
	//CRect rect;
	GetClientRect(&rect);
	dc.MoveTo(0, 0);
	dc.LineTo(rect.right, rect.bottom);
	dc.MoveTo(0, rect.bottom);
	dc.LineTo(rect.right, 0);

	// 3. point
	for(int x=0; x<256; x++)
		for(int y=0; y<256; y++)
			dc.SetPixelV((x + 500), (y + 30), RGB(x, y, 0));

	// 4. bitmap
	// Ʈ ҽ ε  ũ  ´.
	CBitmap bitmap;
	bitmap.LoadBitmap(IDB_BITMAP1);
	BITMAP bmpinfo;
	bitmap.GetBitmap(&bmpinfo);
	// ޸ ̽ ؽƮ   Ʈ  ִ´.
	CDC dcmem;
	dcmem.CreateCompatibleDC(&dc);
	dcmem.SelectObject(&bitmap);
	// Ʈ ȭ鿡 Ѵ.
	dc.BitBlt(850, 350, bmpinfo.bmWidth, bmpinfo.bmHeight, 
		&dcmem, 0, 0, SRCCOPY);
	dc.StretchBlt(950, 350, bmpinfo.bmWidth*4, bmpinfo.bmHeight*6, 
		&dcmem, 0, 0, bmpinfo.bmWidth, bmpinfo.bmHeight, SRCCOPY);

	// 5. bitmap brush
	CBitmap bitmap2;
	bitmap2.LoadBitmap(IDB_BITMAP2);
	CBrush bitmapBrush(&bitmap2);
	dc.SelectObject(&bitmapBrush);
	dc.Ellipse(800, 30, 1100, 330);

	// 6. bitmap image file loading
	CDC memdc;
	memdc.CreateCompatibleDC(&dc);
	HBITMAP hImage = (HBITMAP) LoadImage(AfxGetInstanceHandle(), "Ƽ̵.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	memdc.SelectObject(hImage);
	dc.StretchBlt(50, 500, 777, 272, &memdc, 0, 0, 777, 272, SRCCOPY);

	// 7. 
	//   ȸ ĥѴ.
	dc.SelectStockObject(LTGRAY_BRUSH);
	dc.Rectangle(500, 300, 750, 500);
	// ڿ Ѵ.
	dc.SetBkMode(TRANSPARENT);
	dc.TextOut(500, 400, CString("ȳϼ."));

	// 8. text
	GetClientRect(&rect);
	dc.SetTextColor(RGB(255, 0, 0)); // ڻ ...
	dc.SetBkColor(RGB(255, 255, 0)); //  ...
	dc.DrawText(CString("ؽƮ Լ մϴ."), &rect, 
		DT_CENTER|DT_VCENTER|DT_SINGLELINE);

	dc.SetTextAlign(TA_CENTER);
	dc.TextOut(rect.Width()/2, rect.Height()/4, 
		CString("MFC 迡   ȯմϴ."));

    // 9. پ   Ѵ.
    int nPenStyle[] = {PS_SOLID, PS_DASH, PS_DOT, PS_DASHDOT, 
        PS_DASHDOTDOT, PS_NULL, PS_INSIDEFRAME};
    char *PenStyle[] = {"PS_SOLID", "PS_DASH", "PS_DOT", "PS_DASHDOT", 
        "PS_DASHDOTDOT", "PS_NULL", "PS_INSIDEFRAME"};
    dc.SetTextAlign(TA_BASELINE);
    for(int i=0; i<sizeof(nPenStyle)/sizeof(nPenStyle[0]); i++){
        CPen pen(nPenStyle[i], 1, RGB(0, 0, 255));
        dc.SelectObject(&pen);
        CString str = PenStyle[i];
        dc.TextOut(50, 50+i*25, str);
        dc.MoveTo(200, 50+i*25);
        dc.LineTo(400, 50+i*25);
    }
    CPen blackpen(PS_SOLID, 1, RGB(0, 0, 0));
    dc.SelectObject(&blackpen);
    dc.Rectangle(50, 220, 150, 320); //  ̰ 100 簢 ׸.
    CPen pen1(PS_SOLID, 20, RGB(255, 0, 0)); //  20 PS_SOLID  .
    dc.SelectObject(&pen1);
    dc.Ellipse(50, 220, 150, 320); //  100  ׸.
    dc.SelectObject(&blackpen);
    dc.Rectangle(250, 220, 350, 320); //  ̰ 100 簢 ׸.
    CPen pen2(PS_INSIDEFRAME, 20, RGB(255, 0, 0)); //  20 PS_INSIDEFRAME  .
    dc.SelectObject(&pen2);
    dc.Ellipse(250, 220, 350, 320); //  100  ׸.

	// Do not call CWnd::OnPaint() for painting messages
}

